<template>
	<xn-form-container
		:title="formData.id ? '编辑major' : '增加major'"
		:width="700"
		:visible="visible"
		:destroy-on-close="true"
		@close="onClose"
	>
		<a-form ref="formRef" :model="formData" :rules="formRules" layout="vertical">
			<a-form-item label="院系名称：" name="majorName">
				<a-input v-model:value="formData.majorName" placeholder="请输入院系名称" allow-clear />
			</a-form-item>
			<a-form-item label="院系编码：" name="majorCode">
				<a-input v-model:value="formData.majorCode" placeholder="请输入院系编码" allow-clear />
			</a-form-item>
			<a-form-item label="学院id：" name="collegeId">
				<a-input v-model:value="formData.collegeId" placeholder="请输入学院id" allow-clear />
			</a-form-item>
		</a-form>
		<template #footer>
			<a-button style="margin-right: 8px" @click="onClose">关闭</a-button>
			<a-button type="primary" @click="onSubmit" :loading="submitLoading">保存</a-button>
		</template>
	</xn-form-container>
</template>

<script setup name="majorForm">
	import { cloneDeep } from 'lodash-es'
	import { required } from '@/utils/formRules'
	import majorApi from '@/api/course/majorApi'
	// 抽屉状态
	const visible = ref(false)
	const emit = defineEmits({ successful: null })
	const formRef = ref()
	// 表单数据
	const formData = ref({})
	const submitLoading = ref(false)

	// 打开抽屉
	const onOpen = (record) => {
		visible.value = true
		if (record) {
			let recordData = cloneDeep(record)
			formData.value = Object.assign({}, recordData)
		}
	}
	// 关闭抽屉
	const onClose = () => {
		formRef.value.resetFields()
		formData.value = {}
		visible.value = false
	}
	// 默认要校验的
	const formRules = {}
	// 验证并提交数据
	const onSubmit = () => {
		formRef.value.validate().then(() => {
			submitLoading.value = true
			const formDataParam = cloneDeep(formData.value)
			majorApi
				.majorSubmitForm(formDataParam, formDataParam.id)
				.then(() => {
					onClose()
					emit('successful')
				})
				.finally(() => {
					submitLoading.value = false
				})
		})
	}
	// 抛出函数
	defineExpose({
		onOpen
	})
</script>
